import es
import time
import playerlib
import cmdlib
import cfglib
es.ForceServerCommand('es_load pMsg') #required for radio & teamchat
import pMsg.pMsg

info = es.AddonInfo()
info.name        = 'sbExtra'
info.version     = '1.2'
info.author      = 'Eun'
info.basename    = 'sbextra'
info.description = 'calls sb_status automaticly for SourceTV'

# global variables #
TVID = -1 		# holds bot id
TIMESTAMP = 0	# holds timestamp
STATE = 0		# holds the recording state
# end #

sbe_config       = cfglib.AddonCFG('%s/sbe.cfg' % es.getAddonPath(info.basename))
sbe_print        = sbe_config.cvar('sbe_print', 0, 'how messages should be printed (0=none,1=to all,2=bot says it)')
sbe_fireinhole   = sbe_config.cvar('sbe_fireinhole', 1, 'record fire in the hole? (0=no,1=yes)')
sbe_radio        = sbe_config.cvar('sbe_radio', 1, 'record radio? (0=no,1=yes)')
sbe_teamchat     = sbe_config.cvar('sbe_teamchat', 1, 'record team chat? (0=no,1=yes)')
sbe_config.write()

def PrintTV(text):
	global TVID
	es.cexec(TVID, 'echo "' + text + '"')
	
def SayTV(text):
	global TVID
	pMsg.pMsg.pprint(playerlib.getPlayerList('#all'), "#grey" + es.ServerVar("tv_name") + " #default: " + text)
	
def SVPrint(text):
	es.dbgmsg(0, text)

def GetInHMS(seconds):
    hours = seconds / 3600
    seconds -= 3600*hours
    minutes = seconds / 60
    seconds -= 60*minutes
    return "%02d:%02d:%02d" % (hours, minutes, seconds)

	
def ServerEmpty():
	plyrs = playerlib.getPlayerList('#human')
	for ply in plyrs:
		return 0

	return 1
	
def SetTVID():
	global TVID
	TVNAME = es.ServerVar("tv_name")
	plyrs = playerlib.getPlayerList('#spec')
	for ply in plyrs:
		if (ply.name == TVNAME):
			TVID = ply.userid
			return



 
def sbstatus():
	if ServerEmpty() == 0:
		es.ServerCommand("sb_status")
		
		# 2 empty lines, increases the readability ;)
		PrintTV("")
		PrintTV("")
		
		
def sbecmd(args):

	if (len(args) == 0):
		if STATE == 1:
			endstamp = int(time.strftime("%Y%m%d%H%M%S"))
			SVPrint ("[" + info.name + "]: Recording to " + str(es.ServerVar('sbe_name_of_demo')) + " [" + GetInHMS(endstamp - TIMESTAMP) + "]" )
		else:
			SVPrint ("[" + info.name + "]: Not recording");
			SVPrint ("  Possible commands: sbe start <optional filename>" )
			SVPrint ("  Possible commands: sbe stop" )
			SVPrint ("  Possible commands: sbe help" )
	else:
		if (args[0] == "start"):
			if (len(args) == 2):
				startrecording(args[1])
			else:
				startrecording("")
		elif (args[0] == "stop"):
			stoprecording(0)
		elif (args[0] == "help"):
			SVPrint ("[" + info.name + "]: Help" )
			SVPrint ("  With sbExtra (sbe) you can record your server using SourceTV" )
			SVPrint ("  It allows the use of sb_status (by sbsrc) in the demo")
			SVPrint ("")
			SVPrint ("  Commands: ")
			SVPrint ("  sbe start <optional filename> - Start recording a demo" )
			SVPrint ("  sbe stop                      - Stop recording a demo" )
			SVPrint ("  sbe help                      - Show this help" )
			SVPrint ("")
			SVPrint ("  Cvars: ")
			SVPrint ("  sbe_print <0-2>               - how messages should be printed")
			SVPrint ("             0 = no messages, 1 = messages to all players, 2 = messages spoken by TVBot")
			SVPrint ("  sbe_fireinhole <0/1>          - record fire in the hole?")
			SVPrint ("             0 = no, 1 = yes")
			SVPrint ("  sbe_radio <0/1>               - record radio?")
			SVPrint ("             0 = no, 1 = yes")
			SVPrint ("  sbe_teamchat <0/1>            - record team chat?")
			SVPrint ("             0 = no, 1 = yes")
		
	

def startrecording(file):
	global TVID
	global TIMESTAMP
	global STATE
	
	if STATE == 1:
		SVPrint ("[" + info.name + "]: ERROR: allready recording!")
		return
		
		
	# this finds the sourcetv bot #
	if TVID == -1:
		SetTVID()
				
	if TVID == -1: 
		SVPrint ("[" + info.name + "]: ERROR: SourceTV not found, not recording!")
		return
				
	
	if (len(file) > 0):
		# name of demo is the arg
		es.set('sbe_name_of_demo', file)
	else:
		# name of demo generated from time + mapname #
		es.format ('sbe_name_of_demo', "sbe-%1-%2", time.strftime("%Y-%m-%d-%H-%M-%S"), str(es.ServerVar('eventscripts_currentmap')))
	
	# start message #
	if (int(sbe_print) == 1):
		es.msg("#multi", "#green [" + info.name + "]: #lightgreenRecording started.")
	elif (int(sbe_print) == 2):
		SayTV("Recording started.")
	
	# message to console #
	SVPrint("[" + info.name + "]: Recording to " + str(es.ServerVar('sbe_name_of_demo')))

	# set state #
	STATE = 1
	
	# start demo #
	es.ServerCommand("tv_record " + str(es.ServerVar('sbe_name_of_demo')))

	# get start time & print record header #
	TIMESTAMP = int(time.strftime("%Y%m%d%H%M%S"))
	PrintTV("########################## [sbExtra] ##########################")
	PrintTV("###################### RECORDING STARTED ######################")
	PrintTV("##################### " + time.strftime("%H:%M:%S %d.%m.%Y") + " #####################")
	PrintTV("###############################################################")
	
	sbstatus()


def stoprecording(args):
	global TIMESTAMP
	global STATE
	
	if STATE == 0: # if not recording dont stop anything
		SVPrint("[" + info.name + "]: Not Recording")
		return
	
	# get start time & print record header #
	endstamp = int(time.strftime("%Y%m%d%H%M%S"))
	PrintTV("########################## [sbExtra] ##########################")
	PrintTV("###################### RECORDING STOPPED ######################")
	PrintTV("###################### LENGTH: " + GetInHMS(endstamp - TIMESTAMP) + " #######################")
	PrintTV("###############################################################")
	
	# stop message #
	if (int(sbe_print) == 1):
		es.msg("#multi", "#green [" + info.name + "]: #lightgreenRecording stopped [" + GetInHMS(endstamp - TIMESTAMP) + "].")
	elif (int(sbe_print) == 2):
		SayTV("Recording stopped [" + GetInHMS(endstamp - TIMESTAMP) + "].")
	
	# message to console #
	SVPrint("[" + info.name + "]: Recording stopped [" + GetInHMS(endstamp - TIMESTAMP) + "]")
	
	STATE = 0
	es.delayed(1, "tv_stoprecord") # delay it a bit so we can capure the end header



		
def round_start(ev):
	global STATE
	if STATE > 0:
		sbstatus()
		

def radioText(slot):
	if (slot == 2):    return ("Cover Me!")
	elif (slot == 3):  return ("You Take the Point.")
	elif (slot == 4):  return ("Hold This Position.")
	elif (slot == 5):  return ("Regroup Team.")
	elif (slot == 6):  return ("Follow Me.")
	elif (slot == 7):  return ("Taking Fire...Need Assistance!")
	elif (slot == 9):  return ("Go go go!")
	elif (slot == 10): return ("Team, fall back!")
	elif (slot == 11): return ("Stick together, team.")
	elif (slot == 12): return ("Get in position and wait for my go.")
	elif (slot == 13): return ("Storm the Front!")
	elif (slot == 14): return ("Report in, team.")
	elif (slot == 16): return ("Affirmative.")
	elif (slot == 17): return ("Enemy spotted.")
	elif (slot == 18): return ("Need backup.")
	elif (slot == 19): return ("Sector clear.")
	elif (slot == 20): return ("I'm in position.")
	elif (slot == 21): return ("Reporting in.")
	elif (slot == 22): return ("Get out of there, it's gonna blow!")
	elif (slot == 23): return ("Negative.")
	elif (slot == 24): return ("Enemy down.")
	else: return ("0")


def sayFilter(userid,text,teamonly):
	global STATE
	global TVID
	if (STATE == 1 and int(sbe_teamchat) == 1):
		ply = playerlib.getPlayer(userid)
		if teamonly:
			if (ply.isdead == 0):
				dead1 = ''
				dead2 = ''
			else:
				dead1 = '*DEAD*'
				dead2 = ' '

			if (ply.teamid == 2):
				team = '(Terrorist)'
				color = '#red'
			elif (ply.teamid == 3):	
				team = '(Counter-Terrorist)'
				color = '#blue'
			else:	# spectator?
				return(userid,text,teamonly)
			pMsg.pMsg.pprint(TVID,"#default%s%s %s%s #default: %s%s"%(dead1, team, color, ply.name, dead2, text[1:-1]))

    	return(userid,text,teamonly)



def weapon_fire(ev):
	global STATE
	global TVID
	if (STATE == 1 and int(sbe_fireinhole) == 1):
		text = ev['text']
		weapon = ev['es_userweapon']
		team = es.getplayerteam(ev['userid']);
		if (weapon == 'weapon_flashbang' or weapon == 'weapon_hegrenade' or weapon == 'weapon_smokegrenade') :
			if (team == 2):
				pMsg.pMsg.pprint(TVID,"#red" + ev['es_username'] + "#default (RADIO): Fire in the hole!")
			elif (team == 3):	
				pMsg.pMsg.pprint(TVID,"#blue" + ev['es_username'] + "#default (RADIO): Fire in the hole!")

		
def player_radio(ev):
	global STATE
	global TVID
	if (STATE == 1 and int(sbe_radio) == 1):
		text = radioText(int(ev['slot']))
		if (text != "0"):
			weapon = ev['es_userweapon']
			team = es.getplayerteam(ev['userid']);
			if (team == 2):
				pMsg.pMsg.pprint(TVID,"#red" + es.getplayername(ev['userid']) + "#default (RADIO): " + text)
			elif (team == 3):	
				pMsg.pMsg.pprint(TVID,"#blue" + es.getplayername(ev['userid']) + "#default (RADIO): " + text)

		
def load():
	es.set(info.basename,info.version)
	es.makepublic(info.basename)
	cmdlib.registerServerCommand('sbe', sbecmd, "sbe cmd")
	
	sbe_config.execute()
	
	es.addons.registerSayFilter(sayFilter)
	
	
	
def unload():
	cmdlib.unregisterServerCommand('sbe')
	es.addons.unregisterSayFilter(sayFilter)
	if STATE > 0:
		stoprecording(0)